# -*- coding: UTF-8 -*-

from nes_command import Command
from nes_common.config import config
from nes_common.inserter import Inserter
import mysql.nes_exec
import nes_common.logger as logger


class DB_Inserter(Inserter):
    def __init__(self, shop, loadDictStatusSender=None, disableProgressFile=False):
        log = logger.getLogger("Shop", shop['shopId'])
        host = config.getString('mysql', 'host')
        port = config.getInt('mysql', 'port')
        user = config.getString('mysql', 'user')
        password = config.getString('mysql', 'password')
        executor = mysql.nes_exec.Exec(host=host, port=port, user=user, password=password, database='dictionaries',
                                 shopCode=shop['shopId'], loadDictStatusSender=loadDictStatusSender)
        if disableProgressFile:
            executor.progressEnable = None

        log.info('Инициализация')
        Inserter.__init__(self, shop['shopId'], executor)

    def getCommand(self, simpleCommands):
        return Command(self.executor, self.shopCode, simpleCommands=simpleCommands, modes=['ANY', 'CASH'])
