# -*- coding: utf-8 -*-

import mysql.simplesql as sql

tables = ['hotkey', 'hotkeyinvent']


def insertHotKey(hotkey):
    yield sql.Insert(table='hotkey', values={
        'hotkeycode': hotkey.get('hotkeycode', 0),
        'hotkeyname': hotkey.get('hotkeyname', None),
        'bybarcode': 1 if hotkey.get('bybarcode', False) else 0,
    })
    if hotkey.get('inventcodes', None):
        yield sql.Delete(table='hotkeyinvent', whereFields=['hotkeycode'], whereValues=[hotkey.get('hotkeycode', '')])
        for r in hotkey.get('inventcodes'):
            yield sql.Insert(table='hotkeyinvent', values={
                'hotkeycode': hotkey.get('hotkeycode', 0),
                'inventcode': r,
            })


def deleteHotKey(hotkey):
    yield sql.Delete(table='hotkey', whereFields=['hotkeycode'], whereValues=[hotkey.get('hotkeycode', 0)])
    yield sql.Delete(table='hotkeyinvent', whereFields=['hotkeycode'], whereValues=[hotkey.get('hotkeycode', '')])


def clearHotKey():
    yield sql.DeleteAll(table='hotkey')
    yield sql.DeleteAll(table='hotkeyinvent')


def deleteHotKeyByCode(code):
    yield sql.Delete(table='hotkey', whereFields=['hotkeycode'], whereValues=[code])
    yield sql.Delete(table='hotkeyinvent', whereFields=['hotkeycode'], whereValues=[code])
