import mysql.simplesql as sql

tables = ['discountsauto', 'sprices']


def discs(scheme):
    for disc in scheme.get('discountsauto', []):
        yield disc


def discWithDiscScheme(scheme):
    for disc in discs(scheme):
        yield sql.Insert(table='discountsauto', values={
            'shemecode': scheme.get('schemecode', None),
            'disccode': disc.get('disccode', None),
            'name': disc.get('name', None),
            'disctype': disc.get('disctype', None),
            'discmode': disc.get('discmode', None),
            'discsize': disc.get('discsize', None),
            'rtext': disc.get('rtext', None),
            'date_beg': disc.get('datebeg', None) if disc.get('datebeg', None) else None,
            'date_end': disc.get('dateend', None) if disc.get('dateend', None) else None,
            'time_beg': disc.get('timebeg', None) if disc.get('timebeg', None) else None,
            'time_end': disc.get('timeend', None) if disc.get('timeend', None) else None,
            'days_beg': disc.get('daysbeg', 0),
            'days_end': disc.get('daysend', 0),
            'quant_beg': disc.get('quantbeg', None),
            'quant_end': disc.get('quantend', None),
            'sum_beg': disc.get('sumbeg', None),
            'sum_end': disc.get('sumend', None),
            'pricecode': disc.get('pricecode', None),
            'rsummode': disc.get('rsummode', 0),
            'cardgroupcode': disc.get('cardgroupcode', 0),
            'birthdaymode': disc.get('birthdaymode', 0),
            'catalogid': disc.get('catalogid', None),
            'catalogquantbeg': disc.get('catalogquantbeg', None),
            'catalogquantend': disc.get('catalogquantend', None),
            'catalogsumbeg': disc.get('catalogsumbeg', None),
            'catalogsumend': disc.get('catalogsumend', None),
        })


def insertLDiscScheme(scheme):
    yield sql.Insert(table='sprices', values={
        'code': scheme.get('schemecode', None),
        'name': scheme.get('name', None),
        'type': scheme.get('iscardscheme', 0),
        'oncheck': scheme.get('schemeoncheck', None),
        'ext_proc': ''
    })
    disccodes = list(map(lambda disc: disc.get('disccode', None), scheme.get('discountsauto', [])))
    yield sql.DeleteNotNestedItems(table='discountsauto', mainCodeField='shemecode',
            mainCodeValue=scheme.get('schemecode', None), nestedCodeField='disccode', nestedCodeIn=disccodes)
    for d in discWithDiscScheme(scheme):
        yield d


def deleteLDiscScheme(scheme):
    schemecode=scheme.get('schemecode', None)
    yield sql.Delete(table='discountsauto', whereFields=['shemecode'], whereValues=[schemecode])
    yield sql.Delete(table='sprices', whereFields=['code'], whereValues=[schemecode])


def clearLDiscScheme():
    yield sql.DeleteAll(table='discountsauto')
    yield sql.DeleteAll(table='sprices')


def deleteLDiscSchemeByCode(schemecode):
    yield sql.Delete(table='discountsauto', whereFields=['shemecode'], whereValues=[schemecode])
    yield sql.Delete(table='sprices', whereFields=['code'], whereValues=[schemecode])
